# inout

The keyword is used in conjunction with other keywords to refer to the incoming direction.

1. together with the keyword function it is used to designate parameters that may be both read and written inside the parameterized function;
2. together with the keyword port it is used to designate messages or procedures that a given port may both send and receive.
3. together with the keyword signature it is used to designate parameters that may both read and written by the called procedure.

Related keywords:

- function
- port
- signature

### inout...

BNF definition of inout (sense 1 and 3)
BNF definition of inout (sense 2)